<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>DC mean test</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">dataPipeline loop test </H1>

        <H2>Test Objectives</H2>
        Repeat runs of paced dataPipeline jobs with multi DSOs is used to
		<UL>
		<LI>Check integrity of ldas for processing jobs in a production-like environment</LI>	
        <li>Check for API memory leaks and memory corruption, operation of threads</li>
        <li>Measurement of ldas performance </li>
		</UL>
		
		<H2>APIs affected by this test</H2>
		<UL>
        <li>All APIs are exercised via a dataPipeline command.</li>
		</UL>
				
        <H2>Setup</H2>
        <ul>
        <li>ligotools package is required for running this test. Check that it is mounted</li><p>
        <li>Install the following tests script in a directory on the ldas system
		<UL><p>
        <li><CODE><a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/pipeloop.all?rev=HEAD;content-type=text%2Fplain'>pipeloop.all</a> 
        - driver scrpt to bring up all pipeline looping 
        scripts and update the configuration file  of each loop</li>
        <li><CODE><a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/pipeloop.tcl?rev=HEAD;content-type=text%2Fplain'>pipeloop.tcl</a>
         - scrpt to repeatedly submit ldas 
            jobs for a given command</li>
        <li><CODE>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/inspiral.rds?rev=HEAD;content-type=text%2Fplain'>inspiral.rds</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stochastic.rds?rev=HEAD;content-type=text%2Fplain'>stochastic.rds</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/slope.rds?rev=HEAD;content-type=text%2Fplain'>slope.rds</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stackslide.cmd?rev=HEAD;content-type=text%2Fplain'>stackslide.cmd</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/burstwrapper.cmd?rev=HEAD;content-type=text%2Fplain'>burstwrapper.cmd</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/tfclusters.rds?rev=HEAD;content-type=text%2Fplain'>tfcluster.rds</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/knownpulsardemod.rds?rev=HEAD;content-type=text%2Fplain'>knownpulsardemod.rds</a>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/waveburst.rds?rev=HEAD;content-type=text%2Fplain'>waveburst.rds</a>
        - dataPipeline command files, one for each DSO</li>
        <li><CODE>
         <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/dcmean.cmd?rev=HEAD;content-type=text%2Fplain'>dcmean.cmd</a>
         <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/getmeta.cmd?rev=HEAD;content-type=text%2Fplain'>getmeta.cmd</a>
        dcmean.cmd and getmeta.cmd - non dataPipeline jobs to pace with the dataPipeline jobs</li> 
        <li><CODE><font color='blue'>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/inspiral.rds?rev=HEAD;content-type=text%2Fplain'>cont.tcl</a>
        </font>- script to issue resume of loop jobs</li>
        <li><CODE><font color='blue'>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stop.tcl?rev=HEAD;content-type=text%2Fplain'>stop.tcl</a>
        </font>- script to issue removal of loop driver</li>
        <li><CODE><font color='blue'>
        <a href='http://www.ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stop.tcl?rev=HEAD;content-type=text%2Fplain'>wait.tcl</a>
        </font> - script to adjust time interval between dataPipeline jobs</li>
		</UL>
        </li><p>
        <li>S3 raw frame files or S3 RDS L1 data must be mounted on ldas system and known to diskcacheAPI:<p>
        </ul>
        <p>There is a built in check for dc mean test. The test passes if the value is equal to the expexcted limit
        of <font color='green'><b>-2.2270608572370152e-03</b></font>.
        
        <H2>Test Execution</H2>
        <ul>
		<li>cd &lt;your scripts directory&gt;<p>
		
        <B>Usage:</B> <CODE>pipeloop.all &lt;site&gt; </CODE>

        <p>e.g.<pre><font color='brown'>
            pipeloop.all dev 
        </font></pre></li>
        
        <li>set the time interval between pipelines<p>
        <p><pre><font color='brown'>
            wait.tcl &lt;NN&gt; seconds
            e.g. > wait.tcl 30
            35398 - 7.5
            35391 - 7.5
            35392 - 30.0
            35397 - 30.0
            35399 - 30.0
            35390 - 30.0
            35394 - 30.0
            35396 - 30.0
            35393 - 30.0
            35395 - 30.0

        </font></pre></li>
        will send out a dataPipeline every 30 seconds and a dcmean and getMetaData job every 7.5 secs.<p>        
		<p>
		<H2>Test Validation:</H2>
        <ul>
        <li>All jobs should pass </li><p>
        <li>The stackslide DSO and the waveburst DSO sometimes will run into an error at the DSO</li>
        e.g. <pre><font color='red'>
        09/13/04-06:01:28.6: RECV: Subject: LDAS-DEV32082910 error! mpi::newJobCallback: {Rank 1 failed with error message: 
        ( conditionData function ):  Level 1: $Id: dataPipeline.html,v 1.4 2004/10/26 17:33:21 mlei Exp $      
        Status code 24: Some requested input BLK data is missing        function LALConditionData, file StackSlide.c, line 916 }
        
        09/11/04-10:38:26.2: RECV: Subject: LDAS-DEV31963558 error! mpi::newJobCallback: {
        Rank 2 failed with error message: ( applySearch function ):  Level 1: $Id       Status code -1: Recursive error   
        function LALApplySearch, file Search.c, line 1075 
        Level 2: $Id   Status code -1: Recursive error         function LALSlaveWaveburst
        Search, file Search.c, line 210  Level 3: $Id   Status code 101: cannot open /dso-
        test/waveburst/usertag/timeinterval/etg         function LALOutputWaveburst, file 
        Output.c, line 1037 }

        </font></pre>
        
        <li>dcmean.log should show <b>PASS</b> for this test.
        e.g. <pre><font color='green'>
        <b>09/16/04-14:25:47.4: SEND: LDAS-DEV32303751 (1.2.9)</b>
        09/16/04-14:25:54.8: SEND: LDAS-DEV32303758 (1.2.9)
        09/16/04-14:25:55.9: RECV: Subject: LDAS-DEV32303746 results Your results: mean.ilwd can be found at: 
            http://131.215.115.248/ldas_outgoing/jobs/LDAS-DEV_3230/LDAS-DEV32303746
        09/16/04-14:25:58.0: PASS: LDAS-DEV32303746
        <b>09/16/04-14:26:01.5: RECV: Subject: LDAS-DEV32303751 results Your results: mean.ilwd can be found at:  
            http://131.215.115.248/ldas_outgoing/jobs/LDAS-DEV_3230/LDAS-DEV32303751</b>
        09/16/04-14:26:02.4: SEND: LDAS-DEV32303763 (1.2.9)
        <b>09/16/04-14:26:03.5: PASS: LDAS-DEV32303751</b>

        </font></pre>
    </BODY>
</HTML>

